/*

*/

import renderer.scene.*;

import java.awt.Color;

/**
   This file defines a nested model out of two copies of Model_2
   (so there are four copies of Model_1).
<p>
   Here is a graph of the hierarchical structure of Model_4
   in terms of Model_2. You should complete the graph of the
   hierarchical structure of Model_4 in terms of Model_1.
<p>
<pre>{@code
               Model_4
              /   |   \
             /    |    \
       Matrix   empty   nested Models
         I             /             \
                      /               \
                     /                 \
                    /                   \
               Model_2                 Model_2
              /   |   \               /   |   \
             /    |    \             /    |    \
       Matrix   empty  nested   Matrix  empty   nested
         T             Models     TR            Models
}</pre>
*/
public class Model_4 extends Model
{
   public Model_4()
   {
      super();

      Model m1 = new Model_2(Color.red,     Color.black);
      Model m2 = new Model_2(Color.magenta, Color.blue);

      m1.nestedMatrix = Matrix.translate(-2, -2, 0);

      m2.nestedMatrix = Matrix.translate(2, 2, 0)
                       .times(Matrix.rotateZ(180));

      this.nestedModels.add(m1);
      this.nestedModels.add(m2);
   }
}
