/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;

/**
   This program creates a hierarchical scene out of the
   hierarchical (nested) model, Model_4.
<p>
   Draw nine instances of Model_4 (where each instance
   of Model_4 contains four instances of Model_1).
<p>
   Be sure to draw a picture of the scene graph that this program creates.
*/
public class ShowNestedModels_36
{
   public static void main(String[] args)
   {
      // Create a (single!) instance of Model_4.
      Model m4 = new Model_4();

      /*
         Be sure to draw a picture of the graph that this code creates.
      */

      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      scene.addPosition(new Position(m4));

      for (int i = 0; i < 8; i++)
      {
         Position nestedPosition = new Position();
         nestedPosition.model = m4;
         nestedPosition.rotateZ(i*45);
         nestedPosition.translate(0, -11, 0);
         nestedPosition.scale(0.5);
         scene.getPosition(0).addNestedPosition( nestedPosition );
      }

      // Create a FrameBuffer to render our Scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);

      for (int i = 0; i <= 36; i++)
      {
         scene.getPosition(0).matrix2Identity();
         // Push the model away from where the camera is.
         scene.getPosition(0).translate(0, 0, -15);

         scene.getPosition(0).rotateZ(10*i);

         // What does this do?
       //m4.nestedMatrix = Matrix.rotateZ(10*i);

         // Render again.
         fb.clearFB(java.awt.Color.white);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_ShowNestedModels_36_Frame%02d.ppm", i));
      }
   }
}
