/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;

/**
   This file just shows what Model_1 looks like.
*/
public class ShowModel_1
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();

      // Create an instance of Model_1.
      Model m = new Model_1();
      // Set the model's color.
      m.setColor(Color.black);
      // Add the model to the Scene.
      scene.addPosition(new Position(m));


      // Create a FrameBuffer to render our Scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);

      for (int i = 0; i <= 36; i++)
      {
         scene.getPosition(0).matrix2Identity();
         // Push the model away from where the camera is.
         scene.getPosition(0).translate(0, 0, -3);

         scene.getPosition(0).rotateZ(10*i);

         // Render again.
         fb.clearFB(java.awt.Color.white);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_ShowModel_1_Frame%02d.ppm", i));
      }
   }
}
